;Copyright (C) 2004-2005 John T. Haller
;Portions Copyright 2004 mai9
;Portions Copyright 2005 Hobbyscripter

;Website: http://portableapps.com/portable_firefox

;This software is OSI Certified Open Source Software.
;OSI Certified is a certification mark of the Open Source Initiative.

;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.

;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.

;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

!define FULLNAME "Portable Firefox CE" ; edited by hobbyscripter
!define NAME "PortableFirefoxCE" ; edited by hobbyscripter
!define APP "Firefox"
!define VER "1.1.2.0"
!define WEBSITE "portableapps.com/portable_firefox"
!define DEFAULTEXE "firefox.exe"
!define DEFAULTAPPDIR "firefox"
!define DEFAULTUSERPROFILEDIR ""

; == i18n area (added by hobbyscripter)
; include all the language file here
!include "lang\english.nsh"
!include "lang\tradchinese.nsh"

;=== Program Details
Name "${NAME}"
OutFile "..\${NAME}.exe" ; edited by hobbyscripter
Caption "${FULLNAME} - your browser, your way... in your pocket"
VIProductVersion "${VER}"
VIAddVersionKey FileDescription "${FULLNAME} Launcher runs ${APP} from a removable drive"
VIAddVersionKey LegalCopyright "2004-2005 John T. Haller, portions 2004 by mai9" ; edited by hobbyscripter, sorry because in my computer Gerard Balague' (mai9) can't be show correctly
VIAddVersionKey Comments "Allows ${APP} to be run from a removable drive.  For additional details, visit ${WEBSITE}"
VIAddVersionKey CompanyName "by John T. Haller, portions by Gerard Balagu"
VIAddVersionKey OriginalFilename "${NAME}.exe"
VIAddVersionKey FileVersion "${VER}"

;=== Runtime Switches
CRCCheck On
WindowIcon Off
SilentInstall Silent
AutoCloseWindow True

;=== Program Icon
Icon "graphic\${NAME}.ico" ; edited by hobbyscripter

Var PROGRAMDIRECTORY
Var PROFILEDIRECTORY
Var PROFILEDIRECTORYLEN ; added by hobbyscripter, for the Chinese BIG5 Characters support
Var PROFILEDIRECTORYFIREFOXFORMAT ;added by hobbyscripter, for the Chinese BIG5 Characters support
Var PLUGINSDIRECTORY
Var USERPROFILEDIRECTORY
Var ADDITIONALPARAMETERS
Var ALLOWMULTIPLEINSTANCES
Var SKIPCHROMEFIX
Var SKIPCOMPREGFIX
Var EXECSTRING
Var WAITFORPROGRAM
Var PROGRAMEXECUTABLE
Var INIPATH
Var ISFILELINE
Var DISABLESPLASHSCREEN
Var SKIPUSEFIREFOXFORMATPATH ; added by hobbyscripter, for the Chinese BIG5 Characters support
Var SKIPINIFIX ; added by hobbyscripter, to fix ini
Var INIFIXED ; added by hobbyscripter, to fix ini
Var LASTPLATFORMDIR ; added by hobbyscripter, to fix ini
Var LASTPLATFORMDIRLEN ; added by hobbyscripter, to fix ini
Var WAITFORFIREFOXANYWAY ; added by hobbyscripter, for the WAITFORFIREFOX anyway
Var DYNAMICSPLASH ; added by hobbyscripter, for the Dynamic Splash support


Section "Main"
	;=== Find the INI file, if there is one
		IfFileExists "$EXEDIR\${NAME}.ini" "" CheckSubINI
			StrCpy "$INIPATH" "$EXEDIR\"
			Goto ReadINI

	CheckSubINI:
		IfFileExists "$EXEDIR\${NAME}\${NAME}.ini" "" CheckSubSubINI
			StrCpy "$INIPATH" "$EXEDIR\${NAME}\"
			Goto ReadINI

	CheckSubSubINI:
		IfFileExists "$EXEDIR\PortableApps\${NAME}\${NAME}.ini" "" CheckPortableAppsINI
			StrCpy "$INIPATH" "$EXEDIR\PortableApps\${NAME}\"
			Goto ReadINI

	CheckPortableAppsINI:
		IfFileExists "$EXEDIR\Data\${NAME}\${NAME}.ini" ""  NoINI
			StrCpy "$INIPATH" "$EXEDIR\Data\${NAME}\"
			Goto ReadINI

	ReadINI:
		;=== Read the parameters from the INI file
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "${APP}Directory"
		StrCpy "$PROGRAMDIRECTORY" "$EXEDIR\$0"
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "ProfileDirectory"
		StrCpy "$PROFILEDIRECTORY" "$EXEDIR\$0"

		;=== Check that the above required parameters are present
		IfErrors NoINI

		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "PluginsDirectory"
		StrCpy "$PLUGINSDIRECTORY" "$0"
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "AppDataDirectory"
		StrCpy "$USERPROFILEDIRECTORY" "$0"
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "AdditionalParameters"
		StrCpy "$ADDITIONALPARAMETERS" $0
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "AllowMultipleInstances"
		StrCpy "$ALLOWMULTIPLEINSTANCES" $0
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "SkipChromeFix"
		StrCpy "$SKIPCHROMEFIX" $0
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "SkipCompregFix"
		StrCpy "$SKIPCOMPREGFIX" $0
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "WaitFor${APP}"
		StrCpy "$WAITFORPROGRAM" $0
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "${APP}Executable"
		StrCpy "$PROGRAMEXECUTABLE" $0
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "DisableSplashScreen"
		StrCpy "$DISABLESPLASHSCREEN" $0
 		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "SkipUseFirefoxFormatPath" ; added by hobbyscripter, for the Chinese BIG5 Characters support
		StrCpy "$SKIPUSEFIREFOXFORMATPATH" $0
 		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "SkipINIFix" ; added by hobbyscripter, to fix ini
		StrCpy "$SKIPINIFIX" $0
  		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "WaitForFirefoxAnyway" ; for the WAITFORFIREFOX anyway
		StrCpy "$WAITFORFIREFOXANYWAY" $0
  		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "DynamicSplash" ; for the DynamicSplash
		StrCpy "$DYNAMICSPLASH" $0
		
		;=== Any missing unrequired INI entries will be an empty string, ignore associated errors
		ClearErrors

		;=== Correct PROGRAMEXECUTABLE if blank
		StrCmp $PROGRAMEXECUTABLE "" "" EndINI
			StrCpy "$PROGRAMEXECUTABLE" "${DEFAULTEXE}"
			Goto EndINI

	NoINI:
		;=== No INI file, so we'll use the defaults
		StrCpy "$ADDITIONALPARAMETERS" ""
		StrCpy "$ALLOWMULTIPLEINSTANCES" "false"
		StrCpy "$SKIPCHROMEFIX" "false"
		StrCpy "$SKIPCOMPREGFIX" "false"
		StrCpy "$WAITFORPROGRAM" "false"
		StrCpy "$PROGRAMEXECUTABLE" "${DEFAULTEXE}"
		StrCpy "$DISABLESPLASHSCREEN" "false"
		StrCpy "$SKIPUSEFIREFOXFORMATPATH" "false"
		StrCpy "$SKIPINIFIX" "true"
 		StrCpy "$WAITFORFIREFOXANYWAY" "false"
 		StrCpy "$DYNAMICSPLASH" "" ; Add by HobbyScripter for the Dynamic Support

		IfFileExists "$EXEDIR\${DEFAULTAPPDIR}\${DEFAULTEXE}" "" CheckPortableProgramDIR
			StrCpy "$PROGRAMDIRECTORY" "$EXEDIR\${DEFAULTAPPDIR}"
			StrCpy "$PROFILEDIRECTORY" "$EXEDIR\profile"
			StrCpy "$PLUGINSDIRECTORY" "plugins"
			StrCpy "$USERPROFILEDIRECTORY" "userprofile"
			GoTo EndINI

		CheckPortableProgramDIR:
			IfFileExists "$EXEDIR\${NAME}\${DEFAULTAPPDIR}\${DEFAULTEXE}" "" CheckPortableAppsDIR
			StrCpy "$PROGRAMDIRECTORY" "$EXEDIR\${NAME}\${DEFAULTAPPDIR}"
			StrCpy "$PROFILEDIRECTORY" "$EXEDIR\${NAME}\profile"
			StrCpy "$PLUGINSDIRECTORY" "${NAME}\plugins"
			StrCpy "$USERPROFILEDIRECTORY" "${NAME}\userprofile"
			GoTo EndINI

		CheckPortableAppsDIR:
			IfFileExists "$EXEDIR\PortableApps\${NAME}\${DEFAULTAPPDIR}\${DEFAULTEXE}" "" CheckPortableAppsSplitDIR
			StrCpy "$PROGRAMDIRECTORY" "$EXEDIR\PortableApps\${NAME}\${DEFAULTAPPDIR}"
			StrCpy "$PROFILEDIRECTORY" "$EXEDIR\PortableApps\${NAME}\profile"
			StrCpy "$PLUGINSDIRECTORY" "PortableApps\${NAME}\plugins"
			StrCpy "$USERPROFILEDIRECTORY" "PortableApps\${NAME}\userprofile"
			GoTo EndINI

		CheckPortableAppsSplitDIR:
			IfFileExists "$EXEDIR\Apps\${NAME}\${DEFAULTAPPDIR}\${DEFAULTEXE}" "" NoProgramEXE
			StrCpy "$PROGRAMDIRECTORY" "$EXEDIR\Apps\${NAME}\${DEFAULTAPPDIR}"
			StrCpy "$PROFILEDIRECTORY" "$EXEDIR\Data\${NAME}\profile"
			StrCpy "$PLUGINSDIRECTORY" "Apps\${NAME}\plugins"
			IfFileExists "$EXEDIR\Data\UserProfile\*.*" "" UniqueUserProfileDIR
				;=== Shared UserProfile directory
				StrCpy "$USERPROFILEDIRECTORY" "Data\UserProfile"
				GoTo EndINI

			UniqueUserProfileDIR:
				StrCpy "$USERPROFILEDIRECTORY" "Data\${NAME}\userprofile"
			GoTo EndINI	

	EndINI:
		IfFileExists "$PROGRAMDIRECTORY\$PROGRAMEXECUTABLE" FoundProgramEXE

	NoProgramEXE:
		;=== Program executable not where expected
		MessageBox MB_OK|MB_ICONEXCLAMATION `$(NoExecutableFound)` ; edited by hobbyscripter, for the i18n support
		Abort
		
	FoundProgramEXE:
	;=== Check if Firefox is running
	StrCmp $ALLOWMULTIPLEINSTANCES "true" ProfileWork
	FindProcDLL::FindProc "firefox.exe"
		Pop $R0
		StrCmp $R0 "1" "" ProfileWork
		;=== Firefox is already running, check if it is using the portable profile
		IfFileExists "$PROFILEDIRECTORY\parent.lock" ProfileWork
		
		MessageBox MB_OK|MB_ICONINFORMATION `$(FirefoxAlreadyRunning)` ; edited by hobbyscripter, for the i18n support
		Abort
	
	ProfileWork:
	;=== Check for an existing profile
	IfFileExists "$PROFILEDIRECTORY\prefs.js" ProfileFound
		;=== No profile was found
		MessageBox MB_YESNO|MB_ICONQUESTION `$(CreateProfileQuestion)` IDYES CreateProfile ; edited by hobbyscripter, for the i18n support
		MessageBox MB_OK|MB_ICONINFORMATION `$(NoProfileError)` ; edited by hobbyscripter, for the i18n support
		Abort
	
	CreateProfile:
		IfFileExists "$PROFILEDIRECTORY\*.*" ProfileFound
		CreateDirectory "$PROFILEDIRECTORY"

	ProfileFound:
		StrCmp $DISABLESPLASHSCREEN "true" SkipSplashScreen
			;=== Show the splash screen before processing the files
			; Edit by Hobbyscripter
			; To Add Dynamic Change Splash Support
			Var /GLOBAL "SPLASHIMAGENAME"
			StrCmp $DYNAMICSPLASH "" 0 +5
				InitPluginsDir
				File /oname=$PLUGINSDIR\splash.jpg "graphic\${NAME}.jpg" ; edited by hobbyscripter
		        	StrCpy $SPLASHIMAGENAME "$PLUGINSDIR\splash.jpg"
				Goto +4
			StrCpy $SPLASHIMAGENAME $DYNAMICSPLASH
			GetFullPathName $SPLASHIMAGENAME $SPLASHIMAGENAME
			StrCmp $SPLASHIMAGENAME "" -6 0

			StrCmp $WAITFORPROGRAM "true" ShortSplashScreen
			newadvsplash::show /NOUNLOAD 30000 400 0 -1 /L $SPLASHIMAGENAME
			GoTo SkipSplashScreen
			
			ShortSplashScreen:
				newadvsplash::show /NOUNLOAD 3000 200 0 -1 /L $SPLASHIMAGENAME

	SkipSplashScreen:

		;=== Chinese BIG5 Characters convert area (added by hobbyscripter)
		StrCmp $SKIPUSEFIREFOXFORMATPATH "true" UseOrginalPath 0
		StrLen $PROFILEDIRECTORYLEN $PROFILEDIRECTORY
		IntCmp $PROFILEDIRECTORYLEN 341 +3 +3 0
			MessageBox MB_OK|MB_ICONINFORMATION `$(ProfileDirectoryPathTooLong)`
			Goto UseOrginalPath
		BIG52ASCII::convert "$PROFILEDIRECTORY"
		Pop $PROFILEDIRECTORYFIREFOXFORMAT
		Goto +2
                UseOrginalPath:
			StrCpy $PROFILEDIRECTORYFIREFOXFORMAT $PROFILEDIRECTORY

		IfFileExists "$PROFILEDIRECTORY\chrome\chrome.rdf" "" FixCalendarManager

		;=== Adjust the chrome.rdf
		StrCmp $SKIPCHROMEFIX "true" FixPrefsJs ; edited by hobbyscripter, to make sure prefs.js will be fixed
		FileOpen $0 "$PROFILEDIRECTORY\chrome\chrome.rdf" r
		FileOpen $R0 "$PROFILEDIRECTORY\chrome\chrome.rdf.new" w
		ClearErrors ; if there's an error, we're done with the file
	
		NextLine:
			FileWrite $R0 $4
			FileRead $0 $4
			IfErrors NoMoreLines ;== we've reached the end of the file
			StrCpy $5 $4 35
			StrCmp $5 `                   c:baseURL="jar:f` FoundJarLine
			StrCmp $5 `                   c:baseURL="file:` FoundFileLine NextLine

		FoundJarLine:
			StrCpy $R4 40
			StrCpy $ISFILELINE "0"
			GoTo NotYet

		FoundFileLine:
			StrCpy $R4 40
			StrCpy $ISFILELINE "1"

		NotYet:
			IntOp $R4 $R4 + 1
			StrCpy $7 $4 10 $R4 ;=== looking for the point to strip the extension path
			StrCmp $7 "extensions" PathFound NotYet
	
		PathFound:
			StrCpy $5 $4 "" $R4
			StrCmp $ISFILELINE "0" MakeJarLine MakeFileLine

		MakeJarLine:
			StrCpy $4 `                   c:baseURL="jar:file:///$PROFILEDIRECTORYFIREFOXFORMAT/$5` ; edited by hobbyscripter, for the Chinese BIG5 Characters support
			GoTo NextLine

		MakeFileLine:
			StrCpy $4 `                   c:baseURL="file:///$PROFILEDIRECTORYFIREFOXFORMAT/$5` ; edited by hobbyscripter, for the Chinese BIG5 Characters support
			GoTo NextLine

		NoMoreLines:
			FileClose $0
			FileClose $R0

			;=== Backup the chrome.rdf
			CopyFiles "$PROFILEDIRECTORY\chrome\chrome.rdf" "$PROFILEDIRECTORY\chrome\chrome.rdf.old"
			CopyFiles "$PROFILEDIRECTORY\chrome\chrome.rdf.new" "$PROFILEDIRECTORY\chrome\chrome.rdf" 

	FixCalendarManager:
		IfFileExists "$PROFILEDIRECTORY\Calendar\CalendarManager.rdf" "" FixPrefsJs

		FileOpen $0 "$PROFILEDIRECTORY\Calendar\CalendarManager.rdf" r
		FileOpen $R0 "$PROFILEDIRECTORY\Calendar\CalendarManager.rdf.new" w
		ClearErrors ; if there's an error, we're done with the file
	
		CMNextLine:
			FileWrite $R0 $4
			FileRead $0 $4
			IfErrors CMNoMoreLines ;== we've reached the end of the file
			StrCpy $5 $4 28
			StrCmp $5 `                   NC:path="` "" CMNextLine
			StrCpy $R4 28
	
		CMNotYet:
			IntOp $R4 $R4 + 1
			StrCpy $7 $4 9 $R4 ; looking for the point to strip the calendar path
			StrCmp $7 "Calendar\" "" CMNotYet
			StrCpy $5 $4 "" $R4
			StrCpy $4 `                   NC:path="$PROFILEDIRECTORYFIREFOXFORMAT\$5` ;=== the adjusted extension path ; edited by hobbyscripter, for the Chinese BIG5 Characters support
			GoTo CMNextLine

		CMNoMoreLines:
			FileClose $0
			FileClose $R0

			;=== Backup the Calendar\CalendarManager.rdf just in case
			CopyFiles "$PROFILEDIRECTORY\Calendar\CalendarManager.rdf" "$PROFILEDIRECTORY\Calendar\CalendarManager.rdf.old"
			CopyFiles "$PROFILEDIRECTORY\Calendar\CalendarManager.rdf.new" "$PROFILEDIRECTORY\Calendar\CalendarManager.rdf" 
	
	FixPrefsJs:
		;IfFileExists "$PROFILEDIRECTORY\prefs.js" "" 0 ; deleted by hobbyscripter, to fix Prefs.js anyway
		;=== Be sure the xul cache is enabled and default browser check is disabled
		FileOpen $0 "$PROFILEDIRECTORY\prefs.js" a
		FileSeek $0 0 END
		FileWriteByte $0 "13"
		FileWriteByte $0 "10"
		FileWrite $0 `user_pref("nglayout.debug.disable_xul_cache", false);`
		FileWriteByte $0 "13"
		FileWriteByte $0 "10"
		FileWrite $0 `user_pref("browser.shell.checkDefaultBrowser", false);`
		FileWriteByte $0 "13"
		FileWriteByte $0 "10"
		FileClose $0

	;FixINI:
	; added by hobbyscripter, in order to make sure firefox.exe won't restart itself
	; note: for the first-created profile, firefox.exe will restart itself
		Var /GLOBAL EXTENSIONPATH
		Var /GLOBAL EXTENSIONSCACHEFILE
		Var /GLOBAL EXTENSIONSCACHENEWFILE
		Var /GLOBAL EXTENSIONSCACHEFILEREADLINE
		Var /GLOBAL EXTENSIONSCACHEFILECOLUMN1
		Var /GLOBAL EXTENSIONSCACHEFILECOLUMN2
		Var /GLOBAL EXTENSIONSCACHEFILECOLUMN3
		Var /GLOBAL EXTENSIONSCACHEFILECOLUMN4
		Var /GLOBAL EXTENSIONSCACHEFILECOLUMN5

		StrCmp "$SKIPINIFIX" "true" RunProgram 0
		
	        ; Fix "compatibility.ini"
		IfFileExists "$PROFILEDIRECTORY\compatibility.ini" 0 RunProgram
		ReadINIStr $LASTPLATFORMDIR "$PROFILEDIRECTORY\compatibility.ini" "Compatibility" "LastPlatformDir"
		WriteINIStr "$PROFILEDIRECTORY\compatibility.ini" "Compatibility" "LastPlatformDir" "$PROGRAMDIRECTORY"
		
		IfFileExists "$PROFILEDIRECTORY\extensions.ini" 0 RunProgram
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "${APP}Directory"
		StrLen $1 $0
		StrCpy $LASTPLATFORMDIR $LASTPLATFORMDIR -$1
		StrCpy $LASTPLATFORMDIR $LASTPLATFORMDIR -1
		StrLen $LASTPLATFORMDIRLEN $LASTPLATFORMDIR

		; Fix "extensions.ini"
                ClearErrors
        	IntOp $R9 0 + 0
 		FixExtensionDirsDoLoop:
		        ReadINIStr $R8 "$PROFILEDIRECTORY\extensions.ini" "ExtensionDirs" "Extension$R9"
		        IfErrors 0 +3
		                ClearErrors
		                Goto EndFixExtensionDirsDoLoop
		        StrCpy $R8 $R8 "" $LASTPLATFORMDIRLEN
		        StrCpy $R8 "$LASTPLATFORMDIR$R8"
		        WriteINIStr "$PROFILEDIRECTORY\extensions.ini" "ExtensionDirs" "Extension$R9" $R8
		        IntOp $R9 $R9 + 1
			Goto FixExtensionDirsDoLoop
		EndFixExtensionDirsDoLoop:

                ClearErrors
        	IntOp $R9 0 + 0
 		FixThemeDirsDoLoop:
		        ReadINIStr $R8 "$PROFILEDIRECTORY\extensions.ini" "ThemeDirs" "Extension$R9"
		        IfErrors 0 +3
		                ClearErrors
		                Goto EndFixThemeDirsDoLoop
		        StrCpy $R8 $R8 "" $LASTPLATFORMDIRLEN
		        StrCpy $R8 "$LASTPLATFORMDIR$R8"
		        WriteINIStr "$PROFILEDIRECTORY\extensions.ini" "ThemeDirs" "Extension$R9" $R8
		        IntOp $R9 $R9 + 1
			Goto FixThemeDirsDoLoop
		EndFixThemeDirsDoLoop:

		; Fix "extensions.cache"
		FileOpen $EXTENSIONSCACHEFILE "$PROFILEDIRECTORY\extensions.cache" r
		FileOpen $EXTENSIONSCACHENEWFILE "$PROFILEDIRECTORY\extensions.cache.new" w

		ClearErrors
		ExtensionsCacheNextLine:
		FileRead $EXTENSIONSCACHEFILE $EXTENSIONSCACHEFILEREADLINE
		IfErrors ExtensionsCacheEnd

		Push $EXTENSIONSCACHEFILEREADLINE ; Split
		Call SplitByTab
		Pop $EXTENSIONSCACHEFILECOLUMN1 ; column 1
		Pop $EXTENSIONSCACHEFILECOLUMN2 ; column 2
		Pop $EXTENSIONSCACHEFILECOLUMN3 ; column 3
		Pop $EXTENSIONSCACHEFILECOLUMN4 ; column 4
		Pop $EXTENSIONSCACHEFILECOLUMN5 ; column 5
		
		StrCmp $EXTENSIONSCACHEFILECOLUMN5 "needs-install$\r$\n" 0 +2
                        StrCpy $INIFIXED "false"

		FileWrite $EXTENSIONSCACHENEWFILE "$EXTENSIONSCACHEFILECOLUMN1$\t" ; Write back
		FileWrite $EXTENSIONSCACHENEWFILE "$EXTENSIONSCACHEFILECOLUMN2$\t" ; Write back
		FileWrite $EXTENSIONSCACHENEWFILE "$EXTENSIONSCACHEFILECOLUMN3$\t" ; Write back

		StrCmp $EXTENSIONSCACHEFILECOLUMN1 "app-global" 0 +2
		        StrCpy $EXTENSIONPATH "$PROGRAMDIRECTORY\extensions\$EXTENSIONSCACHEFILECOLUMN2"
		StrCmp $EXTENSIONSCACHEFILECOLUMN1 "app-profile" 0 +2
		        StrCpy $EXTENSIONPATH "$PROFILEDIRECTORY\extensions\$EXTENSIONSCACHEFILECOLUMN2"

		Push $EXTENSIONPATH
		Call FolderModifiedDate ; note: this doesn't work fine, I don't know why?
		Pop $EXTENSIONSCACHEFILECOLUMN4
		
		FileWrite $EXTENSIONSCACHENEWFILE "$EXTENSIONSCACHEFILECOLUMN4$\t" ; Write back
		FileWrite $EXTENSIONSCACHENEWFILE "$EXTENSIONSCACHEFILECOLUMN5" ; Write back

		Goto ExtensionsCacheNextLine
		ExtensionsCacheEnd:
		ClearErrors

		FileClose $EXTENSIONSCACHENEWFILE
		FileClose $EXTENSIONSCACHEFILE
		Delete "$PROFILEDIRECTORY\extensions.cache"
		Rename "$PROFILEDIRECTORY\extensions.cache.new" "$PROFILEDIRECTORY\extensions.cache"

	RunProgram:
		StrCmp $SKIPCOMPREGFIX "true" GetPassedParameters

		;=== Delete component registry to ensure compatibility with all extensions
		Delete $PROFILEDIRECTORY\compreg.dat

		;=== Check INI Fixed Or Not (added by hobbyscripter, in order to make sure firefox.exe won't restart itself)
		IfFileExists "$PROFILEDIRECTORY\compatibility.ini" 0 +5
		ReadINIStr $0 "$PROFILEDIRECTORY\compatibility.ini" "Compatibility" "LastPlatformDir"
		StrCmp $0 $PROGRAMDIRECTORY 0 +3
                        StrCmp $INIFIXED "false" +2 0
			StrCpy $INIFIXED "true"

	GetPassedParameters:
		;=== Get any passed parameters
		Call GetParameters
		Pop $0
		StrCmp "'$0'" "''" "" LaunchProgramParameters

		;=== No parameters
		StrCpy $EXECSTRING `"$PROGRAMDIRECTORY\$PROGRAMEXECUTABLE" -profile "$PROFILEDIRECTORY"`
		Goto CheckMultipleInstances

	LaunchProgramParameters:
		StrCpy $EXECSTRING `"$PROGRAMDIRECTORY\$PROGRAMEXECUTABLE" -profile "$PROFILEDIRECTORY" $0`

	CheckMultipleInstances:
		StrCmp $ALLOWMULTIPLEINSTANCES "true" "" AdditionalParameters
		System::Call 'Kernel32::SetEnvironmentVariableA(t, t) i("MOZ_NO_REMOTE", "1").r0'

	AdditionalParameters:
		StrCmp $ADDITIONALPARAMETERS "" PluginsEnvironment

		;=== Additional Parameters
		StrCpy $EXECSTRING `$EXECSTRING $ADDITIONALPARAMETERS`

	PluginsEnvironment:
		;=== Set the plugins directory if we have a path
		StrCmp $PLUGINSDIRECTORY "" UserProfileEnvironment
		IfFileExists "$EXEDIR\$PLUGINSDIRECTORY\*.*" "" UserProfileEnvironment
		System::Call 'Kernel32::SetEnvironmentVariableA(t, t) i("MOZ_PLUGIN_PATH", "$EXEDIR\$PLUGINSDIRECTORY").r0'

	UserProfileEnvironment:
		;=== Set the %USERPROFILE% directory if we have a path
		StrCmp $USERPROFILEDIRECTORY "" LaunchNow
		IfFileExists "$EXEDIR\$USERPROFILEDIRECTORY\*.*" "" LaunchNow
		System::Call 'Kernel32::SetEnvironmentVariableA(t, t) i("USERPROFILE", "$EXEDIR\$USERPROFILEDIRECTORY").r0'

	LaunchNow:
		StrCmp $WAITFORPROGRAM "true" LaunchAndWait LaunchAndClose

	LaunchAndWait:
		ExecWait $EXECSTRING
		; == wait for firefox anyway (added by hobbyscripter)
		; note: this will only be used if the $INIFIXED is not true
		StrCmp $WAITFORFIREFOXANYWAY "true" +4 0
		StrCmp $INIFIXED "true" TheEnd 0
        		IfFileExists "$PROFILEDIRECTORY\compatibility.ini" 0 TheEnd ; this code is for Firefox 1.0.7 or older.
			MessageBox MB_TOPMOST|MB_SETFOREGROUND|MB_YESNO|MB_ICONQUESTION `$(WaitForFirefoxAnywayQuestion)` IDNO TheEnd
			Sleep 2000
			FindProcDLL::FindProc "$PROGRAMEXECUTABLE"
			Pop $R0
			StrCmp $R0 "1" -3 0
		GoTo TheEnd

	LaunchAndClose:
		Exec $EXECSTRING
		Sleep 3000 ;=== allow the splash screen to show for at least 2 seconds after starting Firefox
		StrCmp $DISABLESPLASHSCREEN "true" TheEnd
			newadvsplash::stop

	TheEnd:

SectionEnd

; == The Timer Library
; added by hobbyscripter, in order to make sure firefox.exe won't restart itself
!include "Timer.lib.nsh"

; == Split By Tab Function
; added by hobbyscripter, in order to make sure firefox.exe won't restart itself
; this function will split a string into four strings by \t
Var SPLIT_A
Var SPLIT_B
Var SPLIT_C
Var SPLIT_D
Var SPLIT_E

Function "SplitByTab"
  Pop $R0
  StrLen $R1 $R0
  IntOp $R2 0 + 0
  StrCpy $SPLIT_A ""
  StrCpy $SPLIT_B ""
  StrCpy $SPLIT_C ""
  StrCpy $SPLIT_D ""
  StrCpy $SPLIT_E ""

  FirstValue:
  IntCmp $R2 $R1 0 0 EndOfSplitLoop
    StrCpy $R3 $R0 1 $R2
    StrCmp $R3 "$\t" 0 +3
        IntOp $R2 $R2 + 1
        Goto SecondValue
      StrCpy $SPLIT_A "$SPLIT_A$R3"
      IntOp $R2 $R2 + 1
      Goto FirstValue

  SecondValue:
  IntCmp $R2 $R1 0 0 EndOfSplitLoop
    StrCpy $R3 $R0 1 $R2
    StrCmp $R3 "$\t" 0 +3
        IntOp $R2 $R2 + 1
        Goto ThirdValue
      StrCpy $SPLIT_B "$SPLIT_B$R3"
      IntOp $R2 $R2 + 1
      Goto SecondValue

  ThirdValue:
  IntCmp $R2 $R1 0 0 EndOfSplitLoop
    StrCpy $R3 $R0 1 $R2
    StrCmp $R3 "$\t"  0 +3
        IntOp $R2 $R2 + 1
        Goto ForthValue
      StrCpy $SPLIT_C "$SPLIT_C$R3"
      IntOp $R2 $R2 + 1
      Goto ThirdValue

  ForthValue:
  IntCmp $R2 $R1 0 0 EndOfSplitLoop
    StrCpy $R3 $R0 1 $R2
    StrCmp $R3 "$\t" 0 +3
        IntOp $R2 $R2 + 1
        Goto FifthValue
      StrCpy $SPLIT_D "$SPLIT_D$R3"
      IntOp $R2 $R2 + 1
      Goto ForthValue

  FifthValue:
  IntCmp $R2 $R1 0 0 EndOfSplitLoop
    StrCpy $R3 $R0 1 $R2
    StrCpy $SPLIT_E "$SPLIT_E$R3"
    IntOp $R2 $R2 + 1
    Goto FifthValue

  EndOfSplitLoop:
  Push $SPLIT_E
  Push $SPLIT_D
  Push $SPLIT_C
  Push $SPLIT_B
  Push $SPLIT_A
FunctionEnd

; == Folder modified date and time
; added by hobbyscripter, in order to make sure firefox.exe won't restart itself
Var FOLDERNAME
Var FILEFINDPOINTER
Var FILENAME
Var FMDTIMER
Var FMDOutput

Function FolderModifiedDate
  Pop $FOLDERNAME

  ; Get the dir's value
  Push "$FOLDERNAME"
  Call FileModifiedDate ; push: FMD
  Call Timer ; pop FMD, push FMDTIMER
  Pop $FMDOutput

  FindFirst $FILEFINDPOINTER $FILENAME "$FOLDERNAME\*"
  loop:
    StrCmp $FILENAME "." notunder
    StrCmp $FILENAME ".." notunder
    Push "$FOLDERNAME\$FILENAME"
    Call FileModifiedDate ; push: FMD
    Call Timer ; pop FMD, push FMDTIMER
    Pop $FMDTIMER

    IntCmp $FMDOutput $FMDTIMER +2 0 +2
      IntOp $FMDOutput $FMDTIMER + 0

    notunder:
    FindNext $FILEFINDPOINTER $FILENAME
    StrCmp $FILENAME "" 0 +3
      ClearErrors
      Goto done
    Goto loop
  done:
  FindClose $FILEFINDPOINTER

  Push "$FMDOutput"
FunctionEnd

; == File modified date and time
; added by hobbyscripter, in order to make sure firefox.exe won't restart itself
; this function is copy from NSIS WIKI and the author is Diego Pedroso(deguix)
Function FileModifiedDate

  # Prepare variables
  Exch $0
  /*Push $1
  Push $2
  Push $3
  Push $4
  Push $5
  Push $6
  Push $7
  Push $R0*/ ; del by hobbyscripter

  # Original System Example (with no dependencies)

  ; create WIN32_FIND_DATA struct
  System::Call '*(i, l, l, l, i, i, i, i, &t260, &t14) i .r2'

  ; Find file info
  System::Call 'kernel32::FindFirstFileA(t, i) i(r0, r2) .r3'

  ; ok?
  IntCmp $3 -1 sgfst_exit

    ; close file search
    System::Call 'kernel32::FindClose(i) i(r3)'

    ; Create systemtime struct for local time
    System::Call '*(&i2, &i2, &i2, &i2, &i2, &i2, &i2, &i2) i .R0'

    ; Get File time
    System::Call '*$2(i, l, l, l, i, i, i, i, &t260, &t14) i (,,, .r3)'

    ; Convert file time (UTC) to local file time
    System::Call 'kernel32::FileTimeToLocalFileTime(*l, *l) i(r3, .r1)'

    ; Convert file time to system time
    System::Call 'kernel32::FileTimeToSystemTime(*l, i) i(r1, R0)'

    sgfst_exit:

  System::Call '*$R0(&i2, &i2, &i2, &i2, &i2, &i2, &i2, &i2)i \
  (.r4, .r5, .r3, .r6, .r2, .r1, .r0,)'

  # Day of week: convert to name
  StrCmp $3 0 0 +3
    StrCpy $3 Sunday
      Goto WeekNameEnd
  StrCmp $3 1 0 +3
    StrCpy $3 Monday
      Goto WeekNameEnd
  StrCmp $3 2 0 +3
    StrCpy $3 Tuesday
      Goto WeekNameEnd
  StrCmp $3 3 0 +3
    StrCpy $3 Wednesday
      Goto WeekNameEnd
  StrCmp $3 4 0 +3
    StrCpy $3 Thursday
      Goto WeekNameEnd
  StrCmp $3 5 0 +3
    StrCpy $3 Friday
      Goto WeekNameEnd
  StrCmp $3 6 0 +2
    StrCpy $3 Saturday
  WeekNameEnd:

  # Month: convert to 2 digits format
	IntCmp $6 9 0 0 +2
	  StrCpy $6 '0$6'

  # Second: convert to 2 digits format
	IntCmp $5 9 0 0 +2
	  StrCpy $5 '0$5'

  # hour: convert to 2 digits format
	IntCmp $2 9 0 0 +2
	  StrCpy $2 '0$2'

  # Minute: convert to 2 digits format
	IntCmp $1 9 0 0 +2
	  StrCpy $1 '0$1'

  # Second: convert to 2 digits format
	IntCmp $0 9 0 0 +2
	  StrCpy $0 '0$0'

  # Return to user
  Push "$4$5$6$2$1$0" ; edited by hobbyscripter
FunctionEnd

Function "GetParameters"
  Push $R0
  Push $R1
  Push $R2
  StrCpy $R2 $CMDLINE 1 0 ; added by hobbyscripter, for the Chinese BIG5 Characters support
  StrCmp $R2 "$\"" 0 +3 ; added by hobbyscripter, for the Chinese BIG5 Characters support
    StrCpy $R0 "" ; added by hobbyscripter, for the Chinese BIG5 Characters support
    Goto ReturnTheValue ; added by hobbyscripter, for the Chinese BIG5 Characters support
  StrCpy $R0 $CMDLINE 1
  StrCpy $R1 '"'
  StrCpy $R2 1
  StrCmp $R0 '"' loop
    StrCpy $R1 ' ' ; we're scanning for a space instead of a quote
  loop:
    StrCpy $R0 $CMDLINE 1 $R2
    StrCmp $R0 $R1 loop2
    StrCmp $R0 "\" "" "nofile"
      IntOp $2 $R2 + 1
    nofile:
    ;MessageBox MB_OK "r0: $R0"
    StrCmp $R0 "" loop2
    IntOp $R2 $R2 + 1
    Goto loop
  loop2:
    IntOp $R0 $R2 - $2
    IntOp $R0 $R0 - 4
    ;MessageBox MB_OK "$R2 - $2 = $R0"
    StrCpy $R7 $CMDLINE $R0 $2 ; we save the filename
    ;MessageBox MB_OK "$2"
  loop2b:
    IntOp $R2 $R2 + 1
    StrCpy $R0 $CMDLINE 1 $R2
    ;MessageBox MB_OK "rr0: $R0"
    StrCmp $R0 " " loop2b
  StrCpy $R0 $CMDLINE "" $R2
  ReturnTheValue: ; added by hobbyscripter, for the Chinese BIG5 Characters support
  Pop $R2
  Pop $R1
  Exch $R0
FunctionEnd